DISK/A DRIV	DB	1		;BIT SET FOR DRIVE
 DRIVE	DB	0		;BINARY DRIVE #
 CTRACK	DB	0,0,0,0		;CURRENT DRIVE TRACK
 DTRACK	DB	17,17,17,17	;DIRECTORY TRACK TABLE
 TRACKS	DB	40,40,80,80	;TRACK COUNT OF DRIVE
 DTYPE	DB	0,0,0,0		;DRIVE TYPE
 ;BIT 7 - 1=HARD / 0=FLOPPY
 ;BIT 6 - 1=8" / 0=5"
 ;BIT 5 - 1=DOUBLE / 0=SINGLE DENSITY
 ;BIT 4 - 1=DOUBLE / 0=SINGLE SIDED
 ;BIT 3 - MOTOR ON DELAY WITH BIT 2
 ;BIT 2 - 00=1 SECOND 01=1/4 10=1/2 11=1/8 ?
 ;BIT 1 - DRIVE STEP SPEED WITH BIT 0
 ;BIT 0 - 00=6MS. 01=12MS. 10=20MS. 11=40MS.
 TRIES	DB	10		;# TRIES B4 ERROR
 RESULT	DB	0		;RESULT OF LAST I/O
 SELECT	LD	A,(37ECH)	;GET DRIVE STATUS
 	RLCA			;TEST BIT 7
 	LD	A,(DRIV)	;GET BIT SET FOR DRIVE
 	LD	(37E1H),A	;SELECT THE DRIVE
 	RET	NC		;MOTOR ALREADY WAS ON
 	PUSH	BC		;SAVE FOR DELAY
 ; GET MOTOR ON DELAY TIME HERE
 	LD	BC,8000H	;1/2 SECOND FOR NOW
 	CALL	DELAY		;DELAY LOOP
 	POP	BC		;RESTORE COUNT
 	LD	A,(37ECH)	;CHECK STATUS AGAIN
 	RLCA
 	RET	NC
 	LD	A,8		;DEVICE NOT AVAILABLE
 	JP	4409H		;DISPLAY ERROR
 READ	LD	A,88H		;READ SECTOR COMMAND
 	LD	HL,021AH	;FOR READ TRANSFER
 	JR	DISKIO		;CONTINUE
 WRITE	LD	A,0A8H		;DATA WRITE COMMAND
 	JR	WRGO		;CONTINUE
 DWRITE	LD	A,0A9H		;DIRECTORY WRITE COMMAND
 WRGO	LD	HL,120AH	;FOR WRITE TRANSFER
 DISKIO	LD	(TYPE+1),A	;SETUP FOR READ/WRITE
 	LD	(PERFM),HL	;SETUP DIRECTION
 	CALL	GETTRK		;GET CURRENT TRACK TO FDC
 	CALL	SELECT		;MOTOR ON
 	CALL	SELDEN		;SELECT DENSITY
 	CALL	SEEK		;MOVE HEAD TO TRACK
 	CALL	SAVTRK		;SAVE CURRENT TRACK
 	LD	A,(TRIES)	;GET # OF TRIES ALLOWED
 	LD	L,A		;SAVE IT HERE
 ATTEMPT	PUSH	HL		;SAVE COUNT
 	CALL	TRANSFER	;TRY IT
 	POP	HL		;GET COUNT BACK
 	LD	(RESULT),A	;SAVE FOR LATER TEST
 	AND	0FCH		;CHECK STATUS
 	RET	Z		;SUCCESS
 	DEC	L		;LESS COUNT
 	JR	NZ,ATTEMPT	;TRY AGAIN ?
 ; COMPUTE ERROR TYPE HERE, RETURN IN A
 	JP	4409H		;DISPLAY ERROR
 SEEK	CALL	SELECT		;MOTOR ON
 	LD	A,(37EDH)	;GET CURRENT TRACK
 	CP	D		;SAME ONE WE WANT ?
 	RET	Z		;YEP
 	OR	A		;TRACK 0 ?
 	CALL	Z,RESTOR	;RESTORE DRIVE IF YES
 	CALL	GETSPEED	;GET DRIVE SPEED
 	OR	18H		;MAKE A SEEK COMMAND
 	LD	(37EEH),DE	;D=>37EFH FOR SEEK
 DOCOMND	LD	(37ECH),A	;GIVE TO FDC
 	CALL	DSKSLO		;SHORT DELAY FOR VALID ST
 SEEKIN	CALL	SELECT		;MOTOR ON FOR LONG SEEK
 	LD	A,(37ECH)	;READ STATUS
 	RRCA			;CHECK BIT 0
 	RET	NC		;DONE IF NOT SET
 	JR	SEEKIN		;ELSE WAIT
 RESTOR	CALL	GETSPEED	;GET DRIVE SPEED
 	OR	8		;MAKE RESTORE COMMAND
 	JR	DOCOMND		;CONTINUE
 DSKSLO	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	RET
 ; COMPUTE DRIVE SPEED FROM TABLE HERE
 GETSPEED	LD	A,3
 	RET
 ; GET TRACK FROM TABLE AND GIVE TO FDC TRACK REGISTER
 GETTRK	RET
 ; PUT TRACK IN TABLE FROM FDC
 SAVTRK	RET
 TRANSFER	CALL	SELECT	;TURN MOTOR ON
 	LD	HL,37ECH	;POINT TO FDC
 	DI			;CAN'T INTERRUPT NOW
 TYPE	LD	(HL),88H	;SET FROM READ/WRITE
 	PUSH	DE		;SAVE TRACK/SECTOR
 	LD	DE,37EFH	;DATA TRANSFER
 	CALL	DSKSLO		;WAIT FOR VALID STATUS
 	JR	XFER		;DO IT
 CHKDONE	BIT	0,(HL)		;COMMAND DONE ?
 	JR	Z,YESDONE
 XFER	BIT	1,(HL)		;BYTE READY ?
 	JR	NZ,PERFM	;DO IT IF SET
 	BIT	1,(HL)
 	JR	NZ,PERFM
 	BIT	1,(HL)
 	JR	NZ,PERFM
 	BIT	1,(HL)
 	JR	NZ,PERFM
 	BIT	1,(HL)
 	JR	NZ,PERFM
 	BIT	1,(HL)
 	JR	NZ,PERFM
 	JR	CHKDONE		;SEE IF COMMAND DONE NOW
 PERFM	LD	A,(DE)		;SETUP FROM READ/WRITE
 	LD	(BC),A
 	INC	BC		;BUMP BUFFER POINTER
 	JP	XFER		;FASTER THAN JR
 YESDONE	LD	A,(HL)		;READ OPERATION STATUS
 	POP	DE		;RESTORE TRACK SECTOR
 	LD	(HL),0D0H	;FORCE INTERRUPT
 	EI			;CAN ENABLE NOW
 	RET
 SELDEN	LD	A,(37EDH)	;MUST SAVE TRACK REGISTER
 	EX	AF,AF'
 ;COMPUTE SINGLE/DOUBLE DENSITY
 	LD	A,0FFH
 	LD	(37ECH),A	;GIVE TO FDC
 	LD	A,0D0H		;FORCE INTERRUPT
 	LD	(37ECH),A
 	EX	AF,AF'		;TRACK REGISTER
 	LD	(37EDH),A	;TO NEW CONTROLLER CHIP
 	RET			;DONE
 DELAY	DEC	C
 	JR	NZ,DELAY
 	DJNZ	DELAY
 	RET
 	END
LD	(37ECH),A	;GIVE TO FDC
 	LD	A,0D0H		;FORCE INTERRUPT
 	LD	(37ECH),A
 	EX	AF,AF'		;TRACK REGISTER
 	LD	(37EDH),A	;TO NEW CONTROLLER CHIP
 	RET			;DONE
 DELAY	DEC	C
 	JR	NZ,DELA