DISKIO CTRACK	DB	0,0,0,0		;CURRENT TRACK OF DRIVE
 ;	DISKIO/ASM
 DIRTRK	DB	17,17,17,17	;DIRECTORY TRACK
 TRACKS	DB	40,40,80,80	;TRACK COUNT OF DRIVE
 TYPE	DB	0,0,0,0		;DRIVE TYPES
 ;BIT 7 = SINGLE/DOUBLE DENSITY
 ;BIT 6 = SINGLE/DOUBLE SIDED
 ;BIT 5 = FLOPPY/HARD
 ;BIT 4 = 5"/8"
 ;BIT 3 =
 ;BIT 2 =
 ;BIT 1 = STEP SPEED
 ;BIT 0 = STEP SPEED
 DRIVE	DB	0		;BINARY DRIVE
 DRIV	DB	0		;BIT SET FOR DRIVE
 SEMFOR	DB	0		;SEMAPHORE BYTE
 ;
 ;  SELECT A DISK DRIVE
 ;  ENTRY:	(DRIV)=CORRECT BIT SET FOR DRIVE
 ;		1=0, 2=1, 4=2, 8=3
 ;  EXIT:	ERROR MESSAGE DISPLAYED IF NOT READY
 ;		A REG. DESTROYED
 ;		ALL OTHERS MAINTAINED
 ;	WAIT 1/4 SECOND FOR MOTOR SPEED IF
 ;		DRIVE IS NOT RUNNING
 SELECT	LD	A,(FDC)		;GET DRIVE STATUS
 	BIT	7,A		;CHECK IF MOTOR ON
 	LD	A,(DRIV)	;GET DRIVE BIT
 	LD	(DDSEL),A	;SELECT IT
 	RET	Z		;DRIVE ALREADY ON
 	PUSH	BC		;SAVE BC
 	LD	BC,4000H	;1/4 SECOND DELAY
 	CALL	DELAY		;DO IT
 	POP	BC		;RESTORE IT
 	LD	A,(FDC)		;GET NEW STATUS
 	BIT	7,A		;CHECK IF DRIVE READY
 	RET	Z		;EVERYTHING OK
 	LD	A,39		;DRIVE NOT READY
 	JP	ERROR		;DISPLAY ERROR & GO DOS
 SELDEN	PUSH	HL		;SAVE IT
 	CALL	GETTYP		;GET DRIVE TYPE
 	POP	HL		;RESTORE
 	BIT	7,A		;DOUBLE DENSITY ?
 	LD	A,0FEH		;SINGLE DENSITY
 	JR	NZ,SELDBL	;SET DOUBLE
 SELDONE	LD	(FDC),A		;SET CONTROLLER
 	LD	A,0D0H		;INTERRUPT
 	LD	(FDC),A		;DO IT
 	RET			;DONE
 SELDBL	LD	A,0FFH		;DOUBLE DENSITY
 	JR	SELDONE		;CONTINUE
 ;
 ;  RESTORE A DISK DRIVE
 ;  ENTRY:	(DRIV)=CORRECT BIT FOR DRIVE
 ;  EXIT:	ERROR MESSAGE DISPLAYED IF NOT IN SYSTEM
 ;		A REG. DESTROYED
 ;		ALL OTHERS MAINTAINED
 ATYPE	DB	0,0,0,0		;CURRENT DRIVE USE TABLE
 RESTOR	CALL	SELECT		;SELECT DRIVE
 	CALL	GETSPD		;GET DRIVE SPEED
 	OR	8		;FOR CHANGE LATER
 	LD	(FDC),A		;GIVE TO CONTROLLER
 	CALL	DSKSLO		;WAIT FOR VALID STATUS
 RESWT	CALL	SELECT		;KEEP MOTOR ON
 	LD	A,(FDC)		;GET STATUS BYTE
 	BIT	0,A		;BUSY BIT
 	JR	NZ,RESWT	;NOT FINISHED
 	BIT	2,A		;HEAD OVER TRACK 0 ?
 	LD	A,0		;SET FOR RETURN
 	RET	NZ		;SET IF YES
 	LD	A,40		;DRIVE NOT IN SYSTEM
 	JP	ERROR		;DISPLAY AND GO DOS
 DSKSLO	EX	(SP),HL		;SHORT DELAY TO ALLOW
 	EX	(SP),HL		;DISK CONTROLLER TO
 	EX	(SP),HL		;GIVE VALID STATUS
 	EX	(SP),HL		;BYTE
 	RET
 ;
 ;  READ A DISK SECTOR
 ;  ENTRY:	(DRIV)=DRIVE TO BE SELECTED
 ;		DE = TRACK/SECTOR TO READ
 ;		BC = LOAD ADDRESS
 ;		C FLAG SET IF DIRECTORY READ
 ;  EXIT:	DE = MAINTAINED
 ;		BC = LAST BYTE IN BUFFER + 1
 ;		HL = DESTROYED
 ;		Z FLAG SET IF OK ELSE A = ERROR CODE
 READ	LD	HL,021AH	;TO MODIFY CODE
 	LD	A,0FCH		;ERROR MASK FOR DATA
 	JR	NC,RDCO		;CARRY=DIRECTORY
 	LD	A,0DCH		;ERROR MASK FOR DIRECTORY
 RDCO	OR	A		;CLEAR CARRY
 	EX	AF,AF'		;MASK IF AF'-NC SET
 	LD	A,88H		;READ COMMAND
 	CALL	ADJSID		;IF SIDE SELECT
 	JR	RDGO		;PERFORM
 ;
 ;  WRITE A DISK SECTOR
 ;  ENTRY & EXIT SAME AS READ
 WRITE	LD	HL,120AH	;TO MODIFY CODE
 	PUSH	AF		;PASS CODE TO AF'
 	LD	A,0FCH		;ERROR MASK
 	SCF			;SET FOR WRITE OP
 	EX	AF,AF'		;MASK IN AF'
 	POP	AF		;GET COMMAND TYPE
 	LD	A,0A8H		;DATA WRITE
 	JR	NC,WRGO		;GO IF NOT DIRECTORY
 	LD	A,0A9H		;DIRECTORY WRITE
 WRGO	CALL	ADJSID		;ADJUST FOR 1795/1791
 RDGO	LD	(CMD1+1),A	;PUT INTO CODE
 	LD	(INST1),HL	;MODIFY EXCHANGE DIRECT
 	CALL	GETTRK		;GET CURRENT TRACK
 	OR	A		;SET FLAGS
 	CALL	Z,RESTOR	;RESTORE DRIVE IF 0
 	LD	(TRACK),A	;GIVE TO TRACK REGISTER
 	PUSH	BC		;SAVE LOAD ADDRESS
 	CALL	TRY1		;TRY ONE TIME
 	POP	HL		;HL=LOAD ADDRESS
 	RET	Z		;OK FIRST TIME
 	LD	B,H		;HL=>BC
 	LD	C,L
 	CALL	TRY1		;TRY ONCE MORE
 	RET	Z		;OK THIS TIME
 	LD	A,L		;GET ERROR CODE
 	RET			;DONE
 TRY1	CALL	SELECT		;SELECT THE DRIVE
 	PUSH	DE		;SAVE DE
 	CALL	ADJTRK		;ADJUST TRACK IF DBL DEN
 	LD	HL,FDC		;CONTROLLER ADDRESS
 	LD	A,(TRACK)	;CURRENT TRACK
 	CP	D		;SAME AS WE'RE LOOKING 4?
 	LD	(SECTOR),DE	;TRACK/SECTOR WE WANT
 	JR	Z,TRANSF	;DON'T BOTHER WITH SEEK
 	CALL	GETSPD		;GET DRIVE SPEED
 	OR	18H		;MAKE SEEK COMMAND
 	LD	(HL),A		;GIVE TO CONTROLLER
 	CALL	DSKSLO		;WAIT FOR VALID
 RDWT	CALL	SELECT		;KEEP MOTOR ON
 	BIT	0,(HL)		;STATUS
 	JR	NZ,RDWT		;WAIT FOR TRACK
 TRANSF	DI			;DISABLE FOR TRANSFER
 CMD1	LD	(HL),0		;COMMAND TO FDC
 	LD	DE,STATUS	;TRANSFER ADDRESS
 	CALL	DSKSLO		;SHORT DELAY
 RDST	BIT	0,(HL)		;COMMAND DONE BIT
 	JR	Z,RDONE		;FINISHED IF NOT SET
 RDBZ	BIT	1,(HL)		;READY BIT
 	JR	NZ,INST1	;GO IF READY
 	BIT	1,(HL)		;CHECK 6 TIMES TO ALLOW
 	JR	NZ,INST1	;FOR FAST TRANSFER OF
 	BIT	1,(HL)		;DOUBLE DENSITY
 	JR	NZ,INST1
 	BIT	1,(HL)
 	JR	NZ,INST1
 	BIT	1,(HL)
 	JR	NZ,INST1
 	BIT	1,(HL)
 	JR	NZ,INST1
 	JR	RDST		;SEE IF DONE
 INST1	LD	A,(DE)		;GET BYTE FROM CONTROLLER
 	LD	(BC),A		;PUT INTO BUFFER
 	INC	BC		;BUMP BUFFER POINTER
 	JR	RDBZ		;WAIT FOR NEXT BYTE
 RDONE	LD	A,(HL)		;GET STATUS
 	LD	(HL),0D0H	;FORCE INTERRUPT
 	EI			;OK FOR INTERRUPTS NOW
 	EX	AF,AF'		;ERROR MASK
 	LD	E,A		;SAVE HERE
 	EX	AF,AF'		;PUT IT BACK
 	AND	E		;TEST FOR ERROR
 	POP	DE		;RESTORE TRACK/SECTOR
 	RET	Z		;DONE - NO ERROR
 	LD	L,39		;DRIVE NOT READY
 	BIT	7,A		;CHECK BIT
 	RET	NZ
 	EX	AF,AF'		;SEE IF READ/WRITE
 	JR	C,WRERR		;WRITE ERROR
 	EX	AF,AF'		;HAVE A READ ERROR
 	LD	L,41		;BAD ID MARK
 	BIT	6,A		;TEST BIT
 	RET	NZ
 	LD	L,42		;READ PROTECTED
 	BIT	5,A
 	RET	NZ
 	LD	L,5		;SECTOR NOT FOUND
 	BIT	4,A
 	RET	NZ
 	LD	L,4		;PARITY ERROR
 	BIT	3,A
 	RET	NZ
 	LD	L,3		;LOST DATA
 	BIT	2,A
 	RET	NZ
 	LD	L,0		;NO ERROR
 	RET
 WRERR	EX	AF,AF'		;RESTORE ERROR
 	LD	L,15		;WRITE PROTECTED
 	BIT	6,A		;CHECK BIT
 	RET	NZ
 	LD	L,14		;DRIVE FAULT
 	BIT	5,A
 	RET	NZ
 	LD	L,13		;SECTOR NOT FOUND
 	BIT	4,A
 	RET	NZ
 	LD	L,12		;PARITY ERROR
 	BIT	3,A
 	RET	NZ
 	LD	L,11		;LOST DATA
 	BIT	2,A
 	RET	NZ
 	LD	L,0		;NO ERROR
 	RET
 DELAY	DEC	C		;LESS 1
 	JR	NZ,DELAY	;GO TILL 0
 	DJNZ	DELAY		;LOOP FOR HIGH BYTE
 	RET			;DONE
 LKTBL	PUSH	HL		;SAVE HL
 	LD	HL,TYPE		;DRIVE TYPE TABLE
 LOKTBL	LD	A,(DRIVE)	;BINARY DRIVE
 	ADD	A,L
 	LD	L,A
 	LD	A,(HL)		;BYTE FROM TABLE
 	POP	HL		;RESTORE HL
 	RET
 GETSPD	CALL	LKTBL		;GET BYTE FROM TABLE
 	AND	3		;GET SPEED BITS
 	RET			;DONE
 GETTRK	PUSH	HL		;SAVE HL
 	LD	HL,CTRACK	;CURRENT TRACK TABLE
 	JR	LOKTBL		;GET FROM TABLE
 GETDIR	PUSH	HL		;SAVE HL
 	LD	HL,DIRTRK	;POINT TO TABLE
 	JR	LOKTBL		;GET FROM TABLE
 GETTKS	PUSH	HL		;SAVE HL
 	LD	HL,TRACKS	;DRIVE TRACK COUNT
 	JR	LOKTBL		;GET IT
 GETTYP	LD	HL,ATYPE	;CURRENT DRIVE TYPE
 	LD	A,(DRIVE)	;GET DRIVE
 	ADD	A,L		;POINT TO RIGHT BYTE
 	LD	L,A
 	LD	A,(HL)		;GET IT
 	RET			;DONE
 ADJSAV	DEFB	0
 ADJSID	LD	(ADJSAV),A	;SAVE CURRENT COMMAND
 	PUSH	HL		;THIS TOO
 	CALL	GETTYP		;GET DRIVE TYPE
 	POP	HL		;RESTORE IT
 	BIT	6,A		;IF DOUBLE SIDED
 	LD	A,(ADJSAV)	;GET COMMAND BACK
 	RET	Z		;SINGLE SIDED
 	LD	A,D		;GET TRACK
 	BIT	0,A		;SEE IF ODD TRACK
 	LD	A,(ADJSAV)	;GET IT BACK AGAIN
 	SET	1,A		;ENABLE SIDE SELECT
 	RES	3,A		;COMPARE FOR 0
 	RET	Z		;ALL SET
 	SET	3,A		;COMPARE FOR SID 1
 	RET			;DONE
 ADJTRK	CALL	GETTYP		;GET DRIVE TYPE
 	BIT	7,A		;DOUBLE DENSITY BIT
 	RET	Z		;SINGLE DENSITY
 	PUSH	BC		;SAVE LOAD ADDRESS
 	LD	L,D		;TRACK
 	LD	H,0		;HL=DESIRED TRACK 0-255
 	LD	A,10		;X 10
 	PUSH	DE		;SAVE TRACK SECTOR
 	CALL	X10
 	POP	DE
 	LD	H,L
 	LD	L,A
 	LD	D,0
 	ADD	HL,DE
 	LD	A,18		;X18
 	CALL	X18
 	LD	D,L
 	LD	E,A
 	INC	D		;DON'T USE TRACK 0
 	POP	BC		;RESTORE LOAD ADDR
 	RET			;FINISHED
 X10	PUSH	BC		;USING THIS
 	EX	DE,HL
 	LD	C,A
 	LD	HL,0
 	LD	A,L
 	LD	B,8
 XA00	ADD	HL,HL
 	RLA
 	RLC	C
 	JR	NC,XA02
 	ADD	HL,DE
 	ADC	A,0
 XA02	DJNZ	XA00
 	LD	C,A
 	LD	A,L
 	LD	L,H
 	LD	H,C
 	POP	BC
 	RET
 X18	PUSH	DE
 	LD	D,A
 	LD	E,10H
 	XOR	A
 XA04	ADD	HL,HL
 	RLA
 	JR	C,XA06
 	CP	D
 	JR	C,XA08
 XA06	SUB	D
 	INC	L
 XA08	DEC	E
 	JR	NZ,XA04
 	POP	DE
 	RET
 	END
	BC
 	RET
 X18	PUSH	DE
 	LD	D,A
 	LD	E,10H
 	XOR	A
 XA04	ADD	HL,HL
 	RLA
 	JR	C,XA06
 	CP	D
 	JR	C,XA08
 XA06	SUB	D
